; ============ Anaglyph stereo render by Dmitry Maslov aka ABTOMAT, ICQ# 438-012-412
; ============ Using FastImage lib (by Mihail Vostrikov aka MonsterSage, www.fastlibs.com )

; Achtung!
; Because of this stereo render uses FastImage lib, you MUST
; include "FastImage.bb" into your source code AND put "FastImage.dll"
; into directory with your bb-file (and/or exe-file), otherwise it shall not work!

; And you must have anaglyph glasses to see stereo image B-)

Global AnaglyphLeftTexture,AnaglyphRightTexture
Global AnaglyphLeftImage,AnaglyphRightImage

Global AnaglyphLeftR,AnaglyphLeftG,AnaglyphLeftB
Global AnaglyphRightR,AnaglyphRightG,AnaglyphRightB

Function InitAnaglyph() ; You MUST call this function once AFTER using Graphics3D	

	AnaglyphSetLeftColor 255,0,0
	AnaglyphSetRightColor 0,255,255

	i = 8
	Repeat
		i = i+1
		If GraphicsWidth() <= 2^i
			TexW = 2^i
			Exit
		End If
	Forever	
	i = 8
	Repeat
		i = i+1
		If GraphicsHeight() <= 2^i
			TexH = 2^i
			Exit
		End If
	Forever
	 
	AnaglyphLeftTexture = CreateTexture(TexW,TexH,256)
	AnaglyphRightTexture = CreateTexture(TexW,TexH,256)	
	
	AnaglyphLeftImage = CreateImageEx (AnaglyphLeftTexture,TexW,TexH,FI_NONE)
	AnaglyphRightImage = CreateImageEx (AnaglyphRightTexture,TexW,TexH,FI_NONE)
	
End Function

Function AnaglyphRender(rendercam, stereobase#, StartDrawSwitch = 1)

	MoveEntity rendercam,-1*stereobase/2,0,0
	RenderWorld()
	CopyRect 0,0,GraphicsWidth(),GraphicsHeight(), 0,0,BackBuffer(), TextureBuffer(AnaglyphLeftTexture)	
	
	MoveEntity rendercam,stereobase,0,0
	RenderWorld()
	CopyRect 0,0,GraphicsWidth(),GraphicsHeight(), 0,0,BackBuffer(), TextureBuffer(AnaglyphRightTexture)
	
	MoveEntity rendercam,-1*stereobase/2,0,0
	
	SetBuffer BackBuffer()
	
	If StartDrawSwitch Then StartDraw
	
	SetColor AnaglyphLeftR,AnaglyphLeftG,AnaglyphLeftB
	SetBlend FI_ALPHABLEND
	DrawImageEx AnaglyphLeftImage,0,0
	
	SetColor AnaglyphRightR,AnaglyphRightG,AnaglyphRightB
	SetBlend FI_LIGHTBLEND
	DrawImageEx AnaglyphRightImage,0,0
	
	If StartDrawSwitch Then EndDraw
End Function

Function AnaglyphSetLeftColor ( R,G,B )
	AnaglyphLeftR = R
	AnaglyphLeftG = G
	AnaglyphLeftB = B
End Function

Function AnaglyphSetRightColor ( R,G,B )
	AnaglyphRightR = R
	AnaglyphRightG = G
	AnaglyphRightB = B
End Function